%% GUI INITIALIZATION
function varargout = GPDFCCMC_11012016(varargin)
set(0,'units','pixels')
sspix = get(0,'screensize');
H = figure('Position',[sspix(3)*.01 sspix(4)*.05 (sspix(3)*.5) (sspix(4)*.89)]);
global GuIformat vc VIDs

addpath(fullfile(cd,'Matlab 2008-2012'))
addpath(fullfile(cd,'Matlab 2008-2012\Win64'))
if exist(fullfile(cd,'Experiments')) == 0
    mkdir(fullfile(cd,'Experiments'))
end

%% Declare Global variables

GuIformat.DEBUGMODE = 1;
GuIformat.ChamberColumns = 12;
GuIformat.ChamberRows = 4;
GuIformat.KS = 0;
GuIformat.BOXConnected = 0;
GuIformat.Vert1 = .96;
GuIformat.Vert2 = .66;
GuIformat.Vert3 = .6;
GuIformat.Vert4 = 0;
GuIformat.color.c = [255/255 190/255 190/255];
GuIformat.color.o = [102/255 1 1];
GuIformat.color.i = [102/255 1 12/255];
GuIformat.STOP = 1;
GuIformat.PAUSE = 0;
GuIformat.AdvancedScript = '';
GuIformat.RowS = {'HGFEDCBA'};
GuIformat.Experiments = cell(1,3);
GuIformat.Experiments{1,3} = zeros([GuIformat.ChamberRows,GuIformat.ChamberColumns]);
GuIformat.Experiments{1,1} = 'Blank Step';
GuIformat.Treatments = cell(1,13);
GuIformat.Treatments{1,1} = 'Incubate';
GuIformat.Treatments{1,2} = 99;
GuIformat.Treatments{1,3} = 0;
GuIformat.Treatments{1,4} = 0;
GuIformat.Treatments{1,5} = 0;
GuIformat.Treatments{1,6} = 0;
GuIformat.Treatments{1,7} = 0;
GuIformat.Treatments{1,8} = 0;
GuIformat.Treatments{1,9} = 0;
GuIformat.Treatments{1,10} = 0;
GuIformat.Treatments{1,11} = 0;
GuIformat.Treatments{1,12} = 0;
GuIformat.Treatments{1,13} = 0;
GuIformat.Treatments{1,14} = zeros(3,3,2)
GuIformat.StandardInc = 2;
GuIformat.TreatCount = 1;
GuIformat.Direction = 1;
GuIformat.ScriptDir = fullfile(cd,'Experiments');
GuIformat.LRM = {'L','R','M'};
GuIformat.Rows = {'A','B','C','D','E','F','G','H'};
GuIformat.CurrentLigand = 0;
for count = 1:16
    GuIformat.LigandNames{count} = num2str(count);
end

%% Chipdata for automatic program
VIDs.ALLVALVES = [0:23]
VIDs.Ligands=zeros(1,16); % Gives if ligand is active or not
VIDs.LigandNames={'Ligand1','Ligand2','Ligand3','Ligand4','Ligand5','Ligand6','Ligand7','Ligand8','Ligand9','Ligand10','Ligand11','Ligand12','Ligand13','Ligand14','Ligand15','Ligand16'};
VIDs.LigandValueMatrix =      [1     0     1     0     1     0     1     0;
    0     1     1     0     1     0     1     0;
    1     0     0     1     1     0     1     0;
    0     1     0     1     1     0     1     0;
    1     0     1     0     0     1     1     0;
    0     1     1     0     0     1     1     0;
    1     0     0     1     0     1     1     0;
    0     1     0     1     0     1     1     0;
    1     0     1     0     1     0     0     1;
    0     1     1     0     1     0     0     1;
    1     0     0     1     1     0     0     1;
    0     1     0     1     1     0     0     1;
    1     0     1     0     0     1     0     1;
    0     1     1     0     0     1     0     1;
    1     0     0     1     0     1     0     1;
    0     1     0     1     0     1     0     1];

VIDs.LigandValves=[0:7];

VIDs.Row_Matrix = [     0     1     0     1     0     1     0     1     0     1;
     0     1     0     1     0     1     0     1     1     0;
     0     1     0     1     0     1     1     0     0     1;
     0     1     0     1     0     1     1     0     1     0;
     0     1     0     1     1     0     0     1     0     1;
     0     1     0     1     1     0     0     1     1     0;
     0     1     0     1     1     0     1     0     0     1;
     0     1     0     1     1     0     1     0     1     0;
     0     1     1     0     0     1     0     1     0     1;
     0     1     1     0     0     1     0     1     1     0;
     0     1     1     0     0     1     1     0     0     1;
     0     1     1     0     0     1     1     0     1     0;
     0     1     1     0     1     0     0     1     0     1;
     0     1     1     0     1     0     0     1     1     0;
     0     1     1     0     1     0     1     0     0     1;
     0     1     1     0     1     0     1     0     1     0;
     1     0     0     1     0     1     0     1     0     1;
     1     0     0     1     0     1     0     1     1     0;
     1     0     0     1     0     1     1     0     0     1;
     1     0     0     1     0     1     1     0     1     0;
     1     0     0     1     1     0     0     1     0     1;
     1     0     0     1     1     0     0     1     1     0;
     1     0     0     1     1     0     1     0     0     1;
     1     0     0     1     1     0     1     0     1     0;
     1     0     1     0     0     1     0     1     0     1;
     1     0     1     0     0     1     0     1     1     0;
     1     0     1     0     0     1     1     0     0     1;
     1     0     1     0     0     1     1     0     1     0;
     1     0     1     0     1     0     0     1     0     1;
     1     0     1     0     1     0     0     1     1     0;
     1     0     1     0     1     0     1     0     0     1;
     1     0     1     0     1     0     1     0     1     0];

VIDs.RowValvs = [9:18];

%% Valve Names

VIDs.QuickDamp=8;
VIDs.Waste=[23];

%% Chamber

VIDs.SEED=[21];
VIDs.FEED=[20];
VIDs.EXIT=[22];
VIDs.BYPASS=[19];

%% Manual Connect
if GuIformat.DEBUGMODE == 0;
    %% Parameters for connecting to two controller boxes
    % Number of boxes
    vc.num = 2;
    
    % Serial number of USB interface in box #1
    vc.info(1).sn = 'ELX04H5S'; % My System - valves 0-23
    vc.info(1).handle = 0;
    vc.info(1).status = 0;
    vc.info(1).polarity = logical([zeros(1, 24)]);
    
    % Serial number of USB interface in box #2
    vc.info(2).sn = 'ELX04H2P'; % My system first valves 24-47
    vc.info(2).handle = 0;
    vc.info(2).status = 0;
    vc.info(2).polarity = logical([zeros(1, 24)]);
    
    %% Open connection to controller boxes
    vc = vc_open_setup(vc);
    % Check status of both connections
    disp(['Status of box#1 = ' num2str(vc.info(1).status)]);
    disp(['Status of box#2 = ' num2str(vc.info(2).status)]);
    
    %%%%END of SPECIFY NEEDED PARAMETERS
    
end

%% Control Panels
DirectControlPanel;
LigandControlPanel;
ChamberControlPanel;
RunButtonPanel;
BoxControlPanel;

end

%% PANEL CONTROL

function DirectControlPanel

global vc VIDs GuIformat;

Control = uipanel('Visible','on',...
    'Position',[0 .975 1 .025]);
% Create 48 toggle buttons for direct control.

for i = 1:48;
    GuIformat.DirCon(i) = uicontrol(Control,...
        'Units','normalized',...
        'Style','togglebutton',...
        'String',i-1,...
        'UserData',i-1,...
        'Position',[(1/54)*(i-1) 0 (1/54) 1],...
        'HandleVisibility','off',...
        'BackgroundColor',GuIformat.color.c);
    set(GuIformat.DirCon(i),'callback',@togglebutton_Callback);
end

GuIformat.DirCon(49) = uicontrol(Control,...
    'Units','normalized',...
    'Style','togglebutton',...
    'String','Open all',...
    'UserData',VIDs.ALLVALVES,...
    'Position',[(1/54)*(48) 0 (3/54) 1],...
    'HandleVisibility','off',...
    'BackgroundColor',GuIformat.color.c);
set(GuIformat.DirCon(49),'callback',@OpenAll_Callback);
    function OpenAll_Callback(hObject,callbackdata)
        button_state = get(hObject,'Value');
        display(button_state)
        NUMBERS = get(hObject,'UserData');
        if button_state == get(hObject,'Max')
            set(hObject,'String','Close All')
            set(hObject, 'BackgroundColor',GuIformat.color.o);
            for i = NUMBERS(randperm(length(NUMBERS)))
                set(GuIformat.DirCon(i+1), 'BackgroundColor',GuIformat.color.o);
                OPEN_VALVES(i);
                pause(.1)
            end
        elseif button_state == get(hObject,'Min')
            set(hObject,'String','Open All')
            set(hObject, 'BackgroundColor',GuIformat.color.c);
            for i = NUMBERS(randperm(length(NUMBERS)))
                set(GuIformat.DirCon(i+1), 'BackgroundColor',GuIformat.color.c);
                CLOSE_VALVES(i);
                pause(.1)
            end
        end
    end

GuIformat.DirCon(50) = uicontrol(Control,...
    'Units','normalized',...
    'Style','togglebutton',...
    'String','Holding Pattern Off',...
    'UserData',VIDs.ALLVALVES,...
    'Position',[(1/54)*(51) 0 (3/54) 1],...
    'HandleVisibility','off',...
    'BackgroundColor',GuIformat.color.c);
set(GuIformat.DirCon(50),'callback',@HoldingPattern_TBCallback);
    function HoldingPattern_TBCallback(hObject,callbackdata)
        
        button_state = get(hObject,'Value');
        display(button_state)
        NUMBERS = get(hObject,'UserData');
        if button_state == get(hObject,'Max')
            GuIformat.STOP = 0
            set(hObject,'String','Holding Pattern On')
            set(hObject, 'BackgroundColor',GuIformat.color.o);
            while GuIformat.STOP == 0
                for i = NUMBERS(randperm(length(NUMBERS)))
                    if GuIformat.STOP == 0
                        CLOSE_VALVES(i)
                        pause(.25)
                        OPEN_VALVES(i)
                    end
                end
            end
        elseif button_state == get(hObject,'Min')
            set(hObject,'String','Holding Pattern Off')
            set(hObject, 'BackgroundColor',GuIformat.color.c);
            GuIformat.STOP = 1;
            for i = NUMBERS(randperm(length(NUMBERS)))
                
                CLOSE_VALVES(i)
                pause(.25)
                
            end
        end
        set(hObject,'String','Holding Pattern Off')
        set(hObject, 'BackgroundColor',GuIformat.color.c);
            for i = NUMBERS(randperm(length(NUMBERS)))
                
                CLOSE_VALVES(i)
                pause(.25)
                
            end
    end

end

function LigandControlPanel

global vc VIDs GuIformat;

Control = uipanel('Visible','on',...
    'Position',[0 .05 .2 .925]);

for i = 16:-1:1
    GuIformat.LigPan(i) = uipanel(Control,...
        'Visible','on',...
        'Position',[0 ((16-i)/16) 1/2 1/16]);
    GuIformat.LigCon(i,1) = uicontrol(GuIformat.LigPan(i),...
        'Units','normalized',...
        'Style','togglebutton',...
        'String',strcat({'Input '},GuIformat.LigandNames{i}),...
        'UserData',i,...
        'Position',[0 (2/3) 1 (1/3)],...
        'HandleVisibility','off',...
        'BackgroundColor',GuIformat.color.c,...
        'callback',@LigandX_Callback);
    GuIformat.LigCon(i,2) = uicontrol(GuIformat.LigPan(i),...
        'Units','normalized',...
        'Style','edit',...
        'String',num2str(i),...
        'UserData',i,...
        'Position',[0 (1/3) 1 (1/3)],...
        'HandleVisibility','off',...
        'callback',@LigEditBox_Callback);
    GuIformat.LigCon(i,3) = uicontrol(GuIformat.LigPan(i),...
        'Units','normalized',...
        'Style','Checkbox',...
        'String',strcat({'Debubble '},GuIformat.LigandNames{i}),...
        'UserData',i,...
        'Position',[0 (0/3) 1 (1/3)],...
        'HandleVisibility','off');
end

GuIformat.QuickDump = uicontrol(Control,...
    'Units','normalized',...
    'Style','togglebutton',...
    'String',strcat({'QuickDump'}),...
    'Userdata',VIDs.QuickDamp,...
    'Position',[1/2 (0/16) (1/2) (16/16)],...
    'HandleVisibility','off',...
    'BackgroundColor',GuIformat.color.c,...
    'callback',@togglebutton_Callback);

    function LigEditBox_Callback(hObject, callbackdata)
        input = get(hObject,'String');
        LigNum = get(hObject,'UserData');
        set(GuIformat.LigCon(LigNum,3),'Value',1)
        crrntLigSet = get(GuIformat.Cham(1,4),'String');
        crrntLigSet{LigNum} = input;
        NewLigSet = crrntLigSet;
        GuIformat.LigandNames{LigNum} = input;
        for i = 1:32
            set(GuIformat.Cham(i,4),'String',NewLigSet);
            set(GuIformat.Cham(i,5),'String',NewLigSet);
        end
        set(GuIformat.SeedChipPUM,'String',NewLigSet);
        set(GuIformat.WashChipPUM,'String',NewLigSet);
        set(GuIformat.CoatChipPUM,'String',NewLigSet);
    end

   end

function ChamberControlPanel

global GuIformat vc VIDs

TABGROUP = uitabgroup('Visible','on',...
    'Position',[.2 .05 .8 .925]);

% %% Automated Setup
% GuIformat.SDNGpanel = uitab('Parent',TABGROUP,'Title','CHIP SETUP');
% 
% DebubblePanel = uipanel(GuIformat.SDNGpanel,...
%     'Visible','on',...
%     'Position',[(0/24) (23/24) (24/24) (1/24)]);
% GuIformat.DebubbleChipCB = uicontrol(DebubblePanel,...
%     'Units','normalized',...
%     'Style','checkbox',...
%     'Value',1,...
%     'Horizontalalignment','center',...
%     'String','Debubble Selected Inputs',...
%     'Position',[(0/24) (0/24) (24/24) (24/24)],...
%     'HandleVisibility','off');
% 
% CoatPanel = uipanel(GuIformat.SDNGpanel,...
%     'Visible','on',...
%     'Position',[(0/24) (22/24) (24/24) (1/24)]);
% GuIformat.CoatChipCB = uicontrol(CoatPanel,...
%     'Units','normalized',...
%     'Style','checkbox',...
%     'Value',1,...
%     'String','Coat Chambers With:',...
%     'Position',[(0/24) (0/24) (8/24) (24/24)],...
%     'HandleVisibility','off');
% GuIformat.CoatChipPUM = uicontrol(CoatPanel,...
%     'Units','normalized',...
%     'Style','popupmenu',...
%     'String',GuIformat.LigandNames,...
%     'Position',[(8/24) (0/24) (8/24) (24/24)],...
%     'HandleVisibility','off');
% GuIformat.CoatChipTXT = uicontrol(CoatPanel,...
%     'Units','normalized',...
%     'Style','text',...
%     'String','Time (min):',...
%     'Position',[(16/24) (0/24) (4/24) (24/24)],...
%     'HandleVisibility','off');
% GuIformat.CoatChipEDT = uicontrol(CoatPanel,...
%     'Units','normalized',...
%     'Style','edit',...
%     'String','60',...
%     'Position',[(20/24) (0/24) (4/24) (24/24)],...
%     'HandleVisibility','off');
% 
% WashPanel = uipanel(GuIformat.SDNGpanel,...
%     'Visible','on',...
%     'Position',[(0/24) (21/24) (24/24) (1/24)]);
% GuIformat.WashChipCB = uicontrol(WashPanel,...
%     'Units','normalized',...
%     'Style','checkbox',...
%     'Value',1,...
%     'String','Wash Chambers With:',...
%     'Position',[(0/24) (0/24) (8/24) (24/24)],...
%     'HandleVisibility','off');
% GuIformat.WashChipPUM = uicontrol(WashPanel,...
%     'Units','normalized',...
%     'Style','popupmenu',...
%     'String',GuIformat.LigandNames,...
%     'Position',[(8/24) (0/24) (8/24) (24/24)],...
%     'HandleVisibility','off');
% GuIformat.WashChipTXT = uicontrol(WashPanel,...
%     'Units','normalized',...
%     'Style','text',...
%     'String','Time (min):',...
%     'Position',[(16/24) (0/24) (4/24) (24/24)],...
%     'HandleVisibility','off');
% GuIformat.WashChipEDT = uicontrol(WashPanel,...
%     'Units','normalized',...
%     'Style','edit',...
%     'String','1',...
%     'Position',[(20/24) (0/24) (4/24) (24/24)],...
%     'HandleVisibility','off');
% 
% SeedPanel = uipanel(GuIformat.SDNGpanel,...
%     'Visible','on',...
%     'Position',[(0/24) (19/24) (24/24) (2/24)]);
% GuIformat.SeedChipCB = uicontrol(SeedPanel,...
%     'Units','normalized',...
%     'Style','checkbox',...
%     'Value',0,...
%     'String','Seed Chambers With:',...
%     'Position',[(0/24) (12/24) (8/24) (12/24)],...
%     'HandleVisibility','off');
% GuIformat.SeedChipPUM = uicontrol(SeedPanel,...
%     'Units','normalized',...
%     'Style','popupmenu',...
%     'String',GuIformat.LigandNames,...
%     'Position',[(8/24) (12/24) (8/24) (12/24)],...
%     'HandleVisibility','off');
% GuIformat.SeedChipTXT = uicontrol(SeedPanel,...
%     'Units','normalized',...
%     'Style','text',...
%     'String','Time (min):',...
%     'Position',[(16/24) (12/24) (4/24) (12/24)],...
%     'HandleVisibility','off');
% GuIformat.SeedChipEDT = uicontrol(SeedPanel,...
%     'Units','normalized',...
%     'Style','edit',...
%     'String','1',...
%     'Position',[(20/24) (12/24) (4/24) (12/24)],...
%     'HandleVisibility','off');
% 
% for i = 32:-1:1
%     
%     GuIformat.SeedChamberCB(i) = uicontrol(SeedPanel,...
%         'Units','normalized',...
%         'Style','checkbox',...
%         'String',i,...
%         'Userdata',i,...
%         'Value',1,...
%         'Position',[((i-1)/32) (0/24) (1/32) (12/24)],...
%         'HandleVisibility','off');
%     
% end
% 
% GuIformat.EXPTsetup = uicontrol(GuIformat.SDNGpanel,...
%     'Units','normalized',...
%     'Style','togglebutton',...
%     'String','Run Chip Preperation Protocol',...
%     'BackgroundColor',GuIformat.color.c,...
%     'Position',[(0/24) (17/24) (24/24) (2/24)],...
%     'HandleVisibility','off',...
%     'Callback',@RunChipPre_TB);
%     function RunChipPre_TB(hObject, callbackdata)
%         button_state = get(hObject,'Value');
%         if button_state == get(hObject,'Max')
%             GuIformat.STOP = 0;
%             set(hObject,'String','Stop');
%             set(hObject, 'BackgroundColor',GuIformat.color.o);
%             %Debubble Inputs
%             if get(GuIformat.DebubbleChipCB,'Value')
%                 if GuIformat.STOP == 0
%                     beep 
%                     selection = questdlg('Set flow layer to 6psi.',...
%                         'Close Request Function',...
%                         'Done','Done');
%                     switch selection,
%                         case 'Done',
%                             TSMessage(strcat({' User confirmed flow layer is at 6psi.'}),GuIformat.ScriptDir);
%                     end
%                     OPEN_VALVES(VIDs.QuickDamp);
%                     set(GuIformat.QuickDump, 'BackgroundColor',GuIformat.color.o);
%                     debubbledinputs = 0;
%                     for i = 1:16
%                         display(get(GuIformat.LigCon(i,3),'Value'));
%                         if get(GuIformat.LigCon(i,3),'Value') == 1
%                             if GuIformat.STOP == 0
%                                 debubbledinputs = debubbledinputs + 1
%                                 TSMessage(strcat({' Started debubbling input '},get(GuIformat.LigCon(i,2),'String')),GuIformat.ScriptDir);
%                                 LIGAND_Callback(i);
%                                 count = 0
%                                 while count <= 10 && GuIformat.STOP == 0
%                                     count = count + 1
%                                     pause(1);
%                                 end
%                                 LIGAND_Callback(i);
%                                 TSMessage(strcat({' Started debubbling input '},get(GuIformat.LigCon(i,2),'String')),GuIformat.ScriptDir);
%                             end
%                         end
%                     end
%                     CLOSE_VALVES(VIDs.QuickDamp);
%                     set(GuIformat.QuickDump, 'BackgroundColor',GuIformat.color.c);
%                     overallcount = 0
%                     while overallcount < (debubbledinputs * 2 * 60) && GuIformat.STOP == 0
%                         for i = 1:16
%                             display(get(GuIformat.LigCon(i,3),'Value'));
%                             if get(GuIformat.LigCon(i,3),'Value') == 1
%                                 if GuIformat.STOP == 0
%                                     TSMessage(strcat({' Started debubbling input '},get(GuIformat.LigCon(i,2),'String')),GuIformat.ScriptDir);
%                                     LIGAND_Callback(i);
%                                     count = 0
%                                     while count <= 30 && GuIformat.STOP == 0
%                                         count = count + 1
%                                         overallcount = overallcount + 1
%                                         pause(1);
%                                     end
%                                     LIGAND_Callback(i);
%                                     TSMessage(strcat({' Stopped debubbling input '},get(GuIformat.LigCon(i,2),'String')),GuIformat.ScriptDir);
%                                 end
%                             end
%                         end
%                     end
%                 end
%             end
%             %Coat Chip
%             if get(GuIformat.CoatChipCB,'Value')
%                 LIGAND_Callback(get(GuIformat.CoatChipPUM,'Value'));
%                 OPEN_VALVES([VIDs.RowValvs,VIDs.SEED,VIDs.FEED,VIDs.EXIT,VIDs.BYPASS])
%                 for i = 1:32
%                     if GuIformat.STOP == 0
%                         OPEN_VALVES([RowMult(i)])
%                         set(GuIformat.Cham(i,1), 'BackgroundColor',GuIformat.color.o);
%                         set(GuIformat.ChamQD(i,1), 'BackgroundColor',GuIformat.color.o);
%                         set(GuIformat.ChamQD(i,2), 'BackgroundColor',GuIformat.color.o);
%                     end
%                 end
%                 TSMessage(strcat({' Started coating chip with input '},get(GuIformat.LigCon(get(GuIformat.CoatChipPUM,'Value'),2),'String')),GuIformat.ScriptDir);
%                 count = 0
%                 while count < (str2num(get(GuIformat.CoatChipEDT,'String')) * 60) && GuIformat.STOP == 0
%                     count = count + 1
%                     pause(1)
%                 end
%                 LIGAND_Callback(get(GuIformat.CoatChipPUM,'Value'));
%                 CLOSE_VALVES([VIDs.RowValvs,VIDs.SEED,VIDs.FEED,VIDs.EXIT,VIDs.BYPASS])
%                 TSMessage(strcat({' Stopped coating chip with input '},get(GuIformat.LigCon(get(GuIformat.CoatChipPUM,'Value'),2),'String')),GuIformat.ScriptDir);
%                 for i = 1:32
%                     set(GuIformat.Cham(i,1), 'BackgroundColor',GuIformat.color.c);
%                     set(GuIformat.ChamQD(i,1), 'BackgroundColor',GuIformat.color.c);
%                     set(GuIformat.ChamQD(i,2), 'BackgroundColor',GuIformat.color.c);
%                 end
%             end
%             %Wash Chip
%             if get(GuIformat.WashChipCB,'Value')
%                 LIGAND_Callback(get(GuIformat.WashChipPUM,'Value'));
%                 OPEN_VALVES([VIDs.Waste,VIDs.BYPASS,VIDs.FEED,VIDs.EXIT])
%                 set(GuIformat.WASTE, 'BackgroundColor',GuIformat.color.o);
%                 for qq = 1:32
%                     if GuIformat.STOP == 0
%                         TSMessage(strcat({' Started washing chamber '},num2str(qq),{' with input '},get(GuIformat.LigCon(get(GuIformat.WashChipPUM,'Value'),2),'String')),GuIformat.ScriptDir);
%                         OPEN_VALVES([RowMult(qq)])
%                         
%                         count = 0
%                         while count < (str2num(get(GuIformat.WashChipEDT,'String')) * 60) && GuIformat.STOP == 0
%                             count = count + 5
%                             set(GuIformat.ChamQD(qq,2), 'BackgroundColor',GuIformat.color.o);
%                             OPEN_VALVES(VIDs.BYPASS)
%                             pause(1)
%                             set(GuIformat.ChamQD(qq,2), 'BackgroundColor',GuIformat.color.c);
%                             set(GuIformat.ChamQD(qq,1), 'BackgroundColor',GuIformat.color.o);
%                             CLOSE_VALVES(VIDs.BYPASS)
%                             pause(4)
%                             set(GuIformat.ChamQD(qq,1), 'BackgroundColor',GuIformat.color.c);
%                         end
%                         CLOSE_VALVES([RowMult(qq)])
%                         TSMessage(strcat({' Stopped washing chamber '},num2str(qq),{' with input '},get(GuIformat.LigCon(get(GuIformat.WashChipPUM,'Value'),2),'String')),GuIformat.ScriptDir);
%                         set(GuIformat.ChamQD(qq,2), 'BackgroundColor',GuIformat.color.c);
%                     end
%                 end
%                 CLOSE_VALVES([VIDs.Waste,VIDs.BYPASS,VIDs.FEED,VIDs.EXIT])
%                 set(GuIformat.WASTE, 'BackgroundColor',GuIformat.color.c);
%                 LIGAND_Callback(get(GuIformat.WashChipPUM,'Value'));
%             end
%             %Seed Chip
%             if get(GuIformat.SeedChipCB,'Value')
%                 if GuIformat.STOP == 0
%                     beep
%                     selection = questdlg('Set flow layer to 2.5psi.',...
%                         'Close Request Function',...
%                         'Done','Done');
%                     switch selection,
%                         case 'Done',
%                             TSMessage(strcat({' User confirmed flow layer is at 2.5psi.'}),GuIformat.ScriptDir);
%                     end
%                     LIGAND_Callback(get(GuIformat.SeedChipPUM,'Value'));
%                     set(GuIformat.WASTE, 'BackgroundColor',GuIformat.color.o);
%                     OPEN_VALVES([VIDs.Waste,VIDs.SEED,VIDs.EXIT])
%                     for qq = 1:32
%                         if GuIformat.STOP == 0 && get(GuIformat.SeedChamberCB(qq),'Value')
%                             TSMessage(strcat({' Started seeding chamber '},num2str(qq),{' with input '},get(GuIformat.LigCon(get(GuIformat.SeedChipPUM,'Value'),2),'String')),GuIformat.ScriptDir);
%                             set(GuIformat.Cham(qq,1), 'BackgroundColor',GuIformat.color.o);
%                             OPEN_VALVES([RowMult(qq)])
%                             count = 0
%                             while count < (str2num(get(GuIformat.SeedChipEDT,'String')) * 60) && GuIformat.STOP == 0
%                                 count = count + 1
%                                 pause(1)
%                             end
%                             CLOSE_VALVES([RowMult(qq)])
%                             set(GuIformat.Cham(qq,1), 'BackgroundColor',GuIformat.color.c);
%                             TSMessage(strcat({' Stopped seeding chamber '},num2str(qq),{' with input '},get(GuIformat.LigCon(get(GuIformat.SeedChipPUM,'Value'),2),'String')),GuIformat.ScriptDir);
%                         end
%                     end
%                     CLOSE_VALVES([VIDs.Waste,VIDs.SEED,VIDs.EXIT])
%                     set(GuIformat.WASTE, 'BackgroundColor',GuIformat.color.c);
%                     LIGAND_Callback(get(GuIformat.SeedChipPUM,'Value'));
%                 end
%                 GuIformat.STOP = 1;
%                 set(hObject,'String','Run Chip Preperation Protocol');
%                 set(hObject, 'BackgroundColor',GuIformat.color.c);
%             end
%         else
%             GuIformat.STOP = 1;
%             set(hObject,'String','Run Chip Preperation Protocol');
%             set(hObject, 'BackgroundColor',GuIformat.color.c);
%         end
%     end
% 
% 
% 
% ValveTesting = uicontrol(GuIformat.SDNGpanel,...
%     'Units','normalized',...
%     'Style','togglebutton',...
%     'String','Valve Testing Off',...
%     'UserData',VIDs.ALLVALVES,...
%     'Position',[0 0 (1) .1],...
%     'HandleVisibility','off',...
%     'BackgroundColor',GuIformat.color.c);
% set(ValveTesting,'callback',@TestingPattern_TBCallback);
%     function TestingPattern_TBCallback(hObject,callbackdata)
%         
%         button_state = get(hObject,'Value');
%         display(button_state)
%         NUMBERS = get(hObject,'UserData');
%         if button_state == get(hObject,'Max')
%             GuIformat.STOP = 0
%             set(hObject,'String','Valve Testing On')
%             set(hObject, 'BackgroundColor',GuIformat.color.o);
%             while GuIformat.STOP == 0
%                         OPEN_VALVES([0:2:length(VIDs.ALLVALVES)-1])
%                         pause(1)
%                         CLOSE_VALVES([0:2:length(VIDs.ALLVALVES)-1])
%                         OPEN_VALVES([1:2:length(VIDs.ALLVALVES)])
%                         pause(1)
%                         CLOSE_VALVES([1:2:length(VIDs.ALLVALVES)])
%             end
%         elseif button_state == get(hObject,'Min')
%             set(hObject,'String','Valve Testing Off')
%             set(hObject, 'BackgroundColor',GuIformat.color.c);
%             GuIformat.STOP = 1;
%             CLOSE_VALVES(NUMBERS)
%         end
%         set(hObject,'String','Valve Testing Off')
%         set(hObject, 'BackgroundColor',GuIformat.color.c);
%         CLOSE_VALVES(NUMBERS)
%     end

%% Experiment Parameters
GuIformat.EXPTparameters = uitab('Parent',TABGROUP,'Title','EXPERIMENT PARAMETERS');
for i = 32:-1:1
    GuIformat.ControlPan(i) = uipanel(GuIformat.EXPTparameters,...
        'Visible','on',...
        'Position',[0 (32-i)/32 1 1/32]);
    valves = VIDs.Row_Matrix(i,:);
    valves = VIDs.RowValvs .* valves;
    valves(valves == 0) = [];
    GuIformat.Cham(i,2) = uicontrol( GuIformat.ControlPan(i),...
        'Units','normalized',...
        'Style','checkbox',...
        'Horizontalalignment','center',...
        'UserData',i,...
        'String',i,...
        'Position',[0/24 0 (1/24) (1)],...
        'HandleVisibility','off');
    set(GuIformat.Cham(i,2),'callback',@ChamberEnable_CBCallback);
    GuIformat.Cham(i,3) = uicontrol( GuIformat.ControlPan(i),...
        'Units','normalized',...
        'Style','popupmenu',...
        'String',{'Single Pulse','Constant','Oscillation'},...
        'Enable','off',...
        'Userdata',i,...
        'Position',[(1/24) (12/24) (4/24) (12/24)],...
        'HandleVisibility','off');
    set(GuIformat.Cham(i,3),'callback',@ChamberEXPType_CBCallback)
    GuIformat.Input1(i) = uicontrol( GuIformat.ControlPan(i),...
        'Units','normalized',...
        'Style','Text',...
        'String','Input 1:',...
        'Userdata',i,...
        'Position',[(5/24) (12/24) (2/24) (12/24)],...
        'HandleVisibility','off');
    GuIformat.Input2(i) = uicontrol( GuIformat.ControlPan(i),...
        'Units','normalized',...
        'Style','Text',...
        'String','Input 2:',...
        'Userdata',i,...
        'Position',[(5/24) (0/24) (2/24) (12/24)],...
        'HandleVisibility','off');
    GuIformat.Cham(i,4) = uicontrol( GuIformat.ControlPan(i),...
        'Units','normalized',...
        'Style','popupmenu',...
        'String',GuIformat.LigandNames,...
        'Enable','off',...
        'Userdata',i,...
        'Position',[(7/24) (12/24) (7/24) (12/24)],...
        'HandleVisibility','off');
    GuIformat.Cham(i,5) = uicontrol( GuIformat.ControlPan(i),...
        'Units','normalized',...
        'Style','popupmenu',...
        'String',GuIformat.LigandNames,...
        'Enable','off',...
        'Userdata',i,...
        'Position',[(7/24) (0/24) (7/24) (12/24)],...
        'HandleVisibility','off');
    GuIformat.Time1(i) = uicontrol( GuIformat.ControlPan(i),...
        'Units','normalized',...
        'Style','Text',...
        'String','Time (min):',...
        'Userdata',i,...
        'Position',[(14/24) (12/24) (3/24) (12/24)],...
        'HandleVisibility','off');
    GuIformat.Time2(i) = uicontrol( GuIformat.ControlPan(i),...
        'Units','normalized',...
        'Style','Text',...
        'String','Time (min):',...
        'Userdata',i,...
        'Position',[(14/24) (0/24) (3/24) (12/24)],...
        'HandleVisibility','off');
    GuIformat.Cham(i,6) = uicontrol( GuIformat.ControlPan(i),...
        'Units','normalized',...
        'Style','edit',...
        'String','60',...
        'Enable','off',...
        'Userdata',i,...
        'Position',[(17/24) (12/24) (7/24) (12/24)],...
        'HandleVisibility','off');
    GuIformat.Cham(i,7) = uicontrol( GuIformat.ControlPan(i),...
        'Units','normalized',...
        'Style','edit',...
        'String','60',...
        'Enable','off',...
        'Userdata',i,...
        'Position',[(17/24) (0/24) (7/24) (12/24)],...
        'HandleVisibility','off');
    
    set(GuIformat.Input1(i),'Visible','On')
    set(GuIformat.Input2(i),'Visible','On')
    set(GuIformat.Cham(i,4),'Visible','On')
    set(GuIformat.Cham(i,5),'Visible','On')
    set(GuIformat.Time1(i),'Visible','On')
    set(GuIformat.Time2(i),'Visible','Off')
    set(GuIformat.Cham(i,6),'Visible','On')
    set(GuIformat.Cham(i,7),'Visible','Off')
end

    function ChamberAddress_TBCallback(hObject,callbackdata)
        button_state = get(hObject,'Value')
        valves = get(hObject,'UserData')
        if button_state == 1
            set(hObject, 'BackgroundColor',GuIformat.color.o);
            OPEN_VALVES(valves);
        else
            set(hObject, 'BackgroundColor',GuIformat.color.c);
            CLOSE_VALVES(valves);
        end
    end

    function ChamberEnable_CBCallback(hObject,callbackdata)
        State = get(hObject,'Value')
        Selection = get(hObject,'UserData')
        if State == 1
            for j = 3:7
                set(GuIformat.Cham(Selection,j),'Enable','On')
            end
            if Selection > 1
                if get(GuIformat.Cham(i,2),'Value')
                set(GuIformat.Cham(Selection,3),'Value', get(GuIformat.Cham(Selection-1,3),'Value'))
                set(GuIformat.Cham(Selection,4),'Value', get(GuIformat.Cham(Selection-1,4),'Value'))
                set(GuIformat.Cham(Selection,5),'Value', get(GuIformat.Cham(Selection-1,5),'Value'))
                set(GuIformat.Cham(Selection,4),'Visible', get(GuIformat.Cham(Selection-1,4),'Visible'))
                set(GuIformat.Cham(Selection,5),'Visible', get(GuIformat.Cham(Selection-1,5),'Visible'))
                set(GuIformat.Cham(Selection,6),'String', get(GuIformat.Cham(Selection-1,6),'String'))
                set(GuIformat.Cham(Selection,7),'String', get(GuIformat.Cham(Selection-1,7),'String'))
                set(GuIformat.Cham(Selection,6),'Visible', get(GuIformat.Cham(Selection-1,6),'Visible'))
                set(GuIformat.Cham(Selection,7),'Visible', get(GuIformat.Cham(Selection-1,7),'Visible'))
                
                set(GuIformat.Input1(Selection),'Visible', get(GuIformat.Input1(Selection-1),'Visible'))
                set(GuIformat.Input2(Selection),'Visible', get(GuIformat.Input2(Selection-1),'Visible'))
                set(GuIformat.Time1(Selection),'Visible', get(GuIformat.Time1(Selection-1),'Visible'))
                set(GuIformat.Time2(Selection),'Visible', get(GuIformat.Time2(Selection-1),'Visible'))
                end
            end
        else
            for j = 3:7
                set(GuIformat.Cham(Selection,j),'Enable','Off')
            end
        end
        UpDateSettings
        
    end

    function ChamberEXPType_CBCallback(hObject,callbackdata)
        State = get(hObject,'Value');
        Selection = get(hObject,'Userdata');
        display(Selection);
        if State == 1
            set(GuIformat.Input1(Selection),'Visible','On')
            set(GuIformat.Input2(Selection),'Visible','On')
            set(GuIformat.Cham(Selection,4),'Visible','On')
            set(GuIformat.Cham(Selection,5),'Visible','On')
            set(GuIformat.Time1(Selection),'Visible','On')
            set(GuIformat.Time2(Selection),'Visible','Off')
            set(GuIformat.Cham(Selection,6),'Visible','On')
            set(GuIformat.Cham(Selection,7),'Visible','Off')
        elseif State == 2
            set(GuIformat.Input1(Selection),'Visible','On')
            set(GuIformat.Input2(Selection),'Visible','Off')
            set(GuIformat.Cham(Selection,4),'Visible','On')
            set(GuIformat.Cham(Selection,5),'Visible','Off')
            set(GuIformat.Time1(Selection),'Visible','Off')
            set(GuIformat.Time2(Selection),'Visible','Off')
            set(GuIformat.Cham(Selection,6),'Visible','Off')
            set(GuIformat.Cham(Selection,7),'Visible','Off')
        elseif State == 3
            set(GuIformat.Input1(Selection),'Visible','On')
            set(GuIformat.Input2(Selection),'Visible','On')
            set(GuIformat.Cham(Selection,4),'Visible','On')
            set(GuIformat.Cham(Selection,5),'Visible','On')
            set(GuIformat.Time1(Selection),'Visible','On')
            set(GuIformat.Time2(Selection),'Visible','On')
            set(GuIformat.Cham(Selection,6),'Visible','On')
            set(GuIformat.Cham(Selection,7),'Visible','On')
            
        end
        
        UpDateSettings
    end

    function UpDateSettings
        for i = 32:-1:1
            if get(GuIformat.Cham(i,2),'Value')
                for j = 3:7
                    set(GuIformat.Cham(i,j),'Enable','On')
                end
            else
                for j = 3:7
                    set(GuIformat.Cham(i,j),'Enable','Off')
                end
            end
            if GuIformat.Cham(i,3) == 1
                set(GuIformat.Input1(i),'Visible','On')
                set(GuIformat.Input2(i),'Visible','On')
                set(GuIformat.Cham(i,4),'Visible','On')
                set(GuIformat.Cham(i,5),'Visible','On')
                set(GuIformat.Time1(i),'Visible','On')
                set(GuIformat.Time2(i),'Visible','Off')
                set(GuIformat.Cham(i,6),'Visible','On')
                set(GuIformat.Cham(i,7),'Visible','Off')
            elseif GuIformat.Cham(i,3) == 2
                set(GuIformat.Input1(i),'Visible','On')
                set(GuIformat.Input2(i),'Visible','Off')
                set(GuIformat.Cham(i,4),'Visible','On')
                set(GuIformat.Cham(i,5),'Visible','Off')
                set(GuIformat.Time1(i),'Visible','Off')
                set(GuIformat.Time2(i),'Visible','Off')
                set(GuIformat.Cham(i,6),'Visible','Off')
                set(GuIformat.Cham(i,7),'Visible','Off')
            elseif GuIformat.Cham(i,3) == 3
                set(GuIformat.Input1(i),'Visible','On')
                set(GuIformat.Input2(i),'Visible','On')
                set(GuIformat.Cham(i,4),'Visible','On')
                set(GuIformat.Cham(i,5),'Visible','On')
                set(GuIformat.Time1(i),'Visible','On')
                set(GuIformat.Time2(i),'Visible','On')
                set(GuIformat.Cham(i,6),'Visible','On')
                set(GuIformat.Cham(i,7),'Visible','On')
            end
        end
    end

%% Experiment Backdoor
GuIformat.SettingsPanel = uitab('Parent',TABGROUP,'Title','EXPERIMENT SETTINGS');
QDpanel = uipanel(GuIformat.SettingsPanel,...
        'Visible','on',...
        'Position',[(0/24) (22/24) (12/24) (2/24)]);
GuIformat.EXPTqdCB = uicontrol(QDpanel,...
    'Units','normalized',...
    'Style','checkbox',...
    'Value',1,...
    'String','Quickdump Flush Time (s):',...
    'Position',[(0/24) (12/24) (8/24) (12/24)],...
    'HandleVisibility','off');
GuIformat.EXPTqdEDT = uicontrol(QDpanel,...
    'Units','normalized',...
    'Style','edit',...
    'String','2',...
    'Position',[(8/24) (12/24) (4/24) (12/24)],...
    'HandleVisibility','off');

BPpanel = uipanel(GuIformat.SettingsPanel,...
        'Visible','on',...
        'Position',[(0/24) (20/24) (12/24) (2/24)]);
GuIformat.EXPTbpCB = uicontrol(BPpanel,...
    'Units','normalized',...
    'Style','checkbox',...
    'Value',1,...
    'String','Bypass Flush Time (s):',...
    'Position',[(0/24) (12/24) (8/24) (12/24)],...
    'HandleVisibility','off');
GuIformat.EXPTbpEDT = uicontrol(BPpanel,...
    'Units','normalized',...
    'Style','edit',...
    'String','60',...
    'Position',[(8/24) (12/24) (4/24) (12/24)],...
    'HandleVisibility','off');

Champanel = uipanel(GuIformat.SettingsPanel,...
        'Visible','on',...
        'Position',[(0/24) (18/24) (12/24) (2/24)]);
GuIformat.EXPTChamTXT = uicontrol(Champanel,...
    'Units','normalized',...
    'Style','text',...
    'Value',1,...
    'String','Chamber Flush Time (s):',...
    'Position',[(0/24) (12/24) (8/24) (12/24)],...
    'HandleVisibility','off');
GuIformat.EXPTChamEDT = uicontrol(Champanel,...
    'Units','normalized',...
    'Style','edit',...
    'String','90',...
    'Position',[(8/24) (12/24) (4/24) (12/24)],...
    'HandleVisibility','off');

Maintpanel = uipanel(GuIformat.SettingsPanel,...
        'Visible','on',...
        'Position',[(0/24) (16/24) (12/24) (2/24)]);
GuIformat.EXPTmaintenanceTXT = uicontrol(Maintpanel,...
    'Units','normalized',...
    'Style','text',...
    'Value',1,...
    'String','Maintenance Feeding Cycle (min):',...
    'Position',[(0/24) (12/24) (8/24) (12/24)],...
    'HandleVisibility','off');
GuIformat.EXPTmaintenanceEDT = uicontrol(Maintpanel,...
    'Units','normalized',...
    'Style','edit',...
    'String','60',...
    'Position',[(8/24) (12/24) (4/24) (12/24)],...
    'HandleVisibility','off');

%% Chamber Control
GuIformat.Control = uitab('Parent',TABGROUP,'Title','MANUAL CONTROL');
for i = 32:-1:1
    GuIformat.ChamberPan(i) = uipanel(GuIformat.Control,...
        'Visible','on',...
        'Position',[0 (32-i)/32 .8 1/32]);
    valves = VIDs.Row_Matrix(i,:);
    valves = VIDs.RowValvs .* valves;
    valves(valves == 0) = [];
    
    GuIformat.Cham(i,1) = uicontrol( GuIformat.ChamberPan(i),...
        'Units','normalized',...
        'Style','togglebutton',...
        'String',strcat({'Seed '},num2str(i)),...
        'UserData',[valves,VIDs.SEED,VIDs.EXIT],...
        'Position',[0/3 (0/3) (1/3) (3/3)],...
        'HandleVisibility','off',...
        'BackgroundColor',GuIformat.color.c);
    set(GuIformat.Cham(i,1),'callback',@ChamberAddress_TBCallback);
    GuIformat.ChamQD(i,1) = uicontrol( GuIformat.ChamberPan(i),...
        'Units','normalized',...
        'Style','togglebutton',...
        'String',strcat({'Feed '},num2str(i)),...
        'UserData',[valves,VIDs.FEED,VIDs.EXIT],...
        'Position',[1/3 (0/3) (1/3) (3/3)],...
        'HandleVisibility','off',...
        'BackgroundColor',GuIformat.color.c);
    set(GuIformat.ChamQD(i,1),'callback',@ChamberAddress_TBCallback);
    GuIformat.ChamQD(i,2) = uicontrol( GuIformat.ChamberPan(i),...
        'Units','normalized',...
        'Style','togglebutton',...
        'String',strcat({'Bypass '},num2str(i)),...
        'UserData',[valves,VIDs.BYPASS],...
        'Position',[2/3 (0/3) (1/3) (3/3)],...
        'HandleVisibility','off',...
        'BackgroundColor',GuIformat.color.c);
    set(GuIformat.ChamQD(i,2),'callback',@ChamberAddress_TBCallback);
end

GuIformat.WASTE = uicontrol(GuIformat.Control,...
    'Units','normalized',...
    'Style','togglebutton',...
    'String','Waste',...
    'UserData',[VIDs.Waste],...
    'Position',[.8 (0) (.2) (1)],...
    'HandleVisibility','off',...
    'BackgroundColor',GuIformat.color.c',...
    'Callback',@togglebutton_Callback);

end

function RunButtonPanel
global GuIformat vc VIDs
Control = uipanel('Visible','on',...
    'Position',[.35 0 .65 .05]);
GuIformat.RunButton = uicontrol(Control,...
    'Units','normalized',...
    'Style','togglebutton',...
    'String','Run',...
    'Position',[0 0 .55 1],...
    'HandleVisibility','off',...
    'BackgroundColor',GuIformat.color.c,...
    'Callback',@RunExp);
    function RunExp(hObject,Callbackdata)
        
        if get(hObject,'Value')
            GuIformat.STOP = 0
            beep
            selection = questdlg('Set flow layer to 2.5psi.',...
                'Close Request Function',...
                'Done','Done');
            switch selection,
                case 'Done',
                    TSMessage(strcat({' User confirmed flow layer is at 2.5psi'}),GuIformat.ScriptDir);
            end
            SaveExp(hObject, Callbackdata)
            TSMessage(strcat({' Experiment Started'}),GuIformat.ScriptDir);
            OPEN_VALVES([VIDs.FEED,VIDs.BYPASS,VIDs.EXIT])
            set(hObject, 'BackgroundColor',GuIformat.color.o)
            pause(1)
            set(hObject, 'String','Stop')
            ExpCondVect = zeros(32,5)
            ExpTimeLast = zeros(32,6)
            ExpTimeSwitch = zeros(32,6)
            ExpCrrntInput = zeros(32,1)
            ExpCrrntInc = zeros(32,1)
            for i = [1:32]
                if get(GuIformat.Cham(i,2),'Value')
                    ExpCondVect(i,1) = get(GuIformat.Cham(i,3),'Value') %Type
                    ExpCondVect(i,2) = get(GuIformat.Cham(i,4),'Value'); %Input 1
                    ExpCondVect(i,3) = get(GuIformat.Cham(i,5),'Value'); %Input 2
                    ExpCondVect(i,4) = str2num(get(GuIformat.Cham(i,6),'String')); %Time 1
                    ExpCondVect(i,5) = str2num(get(GuIformat.Cham(i,7),'String')) %Time 2
                    display(ExpCondVect)
                    ExpCrrntInput(i) = 1
                    ExpCrrntInc(i) = ExpCondVect(i,4)
                end
            end
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Run Experiment
            WashMatrix = zeros(32,2)
            CheckTime = clock
            for kk = [1:32]%INITIALIZE CULTURE CONDITIONS
                if get(GuIformat.Cham(kk,2),'Value')
                    WashMatrix(kk,1) = 1
                    WashMatrix(kk,2) = ExpCondVect(kk,2)
                    ExpTimeLast(kk,:) = CheckTime%ESTABLISH INITIAL TIMES FOR MAINTENANCE CYCLE
                    ExpTimeSwitch(kk,:) = CheckTime%ESTABLISH INITIAL TIMES FOR TRANSITION CYCLE
                end
            end
            %WASH WITH INITIAL MEDIA TYPES
            WashChamber(WashMatrix)
            while GuIformat.STOP == 0
                pause(1)
                for qq = [1:32]
                    if get(GuIformat.Cham(qq,2),'Value')
                        etime(clock,ExpTimeSwitch(qq,:))%SHOW ELAPSED TIMES
                    end
                end
                WashMatrix = zeros(32,2);%(yes,media)
                for j = [1:32]
                    if get(GuIformat.Cham(j,2),'Value')
                        CheckTime = clock
                        if etime(clock,ExpTimeSwitch(j,:)) > ExpCrrntInc(j)*60 %IF IT'S THE SCHEDULED TIME TO FEED
                            ExpTimeLast(j,:) = clock;
                            if ExpCondVect(j,1) == 1 %IF SINGLE PULSE
                                if ExpCrrntInput(j) == 1 %IF MEDIA 1 IS IN CHAMBER
                                    ExpCrrntInput(j) = 2;%USE MEDIA 2 FROM NOW ON
                                    ExpTimeSwitch(j,:) =  CheckTime;
                                    ExpCrrntInc(j) = 60*60*24*100;%START USING MAINTENANCE CYCLE FROM NOW ON
                                    Media2Use =  ExpCondVect(j,3);%USE MEDIA 2 FROM NOW ON
                                end
                            elseif ExpCondVect(j,1) == 2 %IF CONSTANT
                                ExpCrrntInput(j) = 1;%USE MEDIA 1
                                ExpTimeSwitch(j,:) =  CheckTime;%USE MEDIA 1
                                ExpCrrntInc(j) = 60*60*24*100;%IGNORE TRANSITION CYCLE
                                Media2Use =  ExpCondVect(j,2);%USE MEDIA 1
                            elseif ExpCondVect(j,1) == 3 %IF OSCILLATION
                                if ExpCrrntInput(j) == 1%IF MEDIA 1 IS IN CHAMBER
                                    ExpCrrntInput(j) = 2;%USE MEDIA 2
                                    ExpTimeSwitch(j,:) = CheckTime;%UPDATE TRANSITION CYCLE WITH NEW TIME
                                    ExpCrrntInc(j) = ExpCondVect(j,5);%USE TRANSITION CYCLE TIMING
                                    Media2Use =  ExpCondVect(j,3);%USE MEDIA 2
                                elseif ExpCrrntInput(j) == 2%IF MEDIA 2 IS IN CHAMBER
                                    ExpCrrntInput(j) = 1;%USE MEDIA 2
                                    ExpTimeSwitch(j,:) = CheckTime;%UPDATE TRANSITION CYCLE
                                    ExpCrrntInc(j) = ExpCondVect(j,4);%USE MEDIA 2
                                    Media2Use =  ExpCondVect(j,2);%USE MEDIA 2
                                end
                            end
                            WashMatrix(j,2) = Media2Use;
                            WashMatrix(j,1) = 1;
                        end
                    end
                end % SCRIPTED FEEDING LOOP
                WashChamber(WashMatrix)
                WashMatrix = zeros(32,2);%(yes,media)
                CheckTime = clock
                for j = [1:32]
                    if get(GuIformat.Cham(j,2),'Value')
                        if etime(clock,ExpTimeLast(j,:)) > str2num(get(GuIformat.EXPTmaintenanceEDT, 'String'))*60 %IF IT'S BEEN 30 MINUTES SINCE THE LAST WASH CYCLE
                            ExpTimeLast(j,:) = CheckTime %UPDATE WASHTIME
                            if ExpCrrntInput(j) == 1 %IF MEDIA 1 IS IN CHAMBER
                                Media2Use =  ExpCondVect(j,2);%USE MEDIA 1
                            else %IF MEDIA 2 IS IN CHAMBER
                                Media2Use =  ExpCondVect(j,3); %USE MEDIA 2
                            end
                            WashMatrix(j,2) = Media2Use;
                            WashMatrix(j,1) = 1;
                        end
                    end
                end % MAINTENANCE FEEDING LOOP
                WashChamber(WashMatrix)
            end
            CLOSE_VALVES([VIDs.FEED,VIDs.BYPASS,VIDs.EXIT])
            TSMessage(strcat({' Experiment Stopped'}),GuIformat.ScriptDir);
            CLOSE_VALVES([2:7,9:18])
%             set(GuIformat.SettingsPanel,'Visible','on')
%             set(GuIformat.SDNGpanel,'Visible','on')
%             set(GuIformat.Control,'Visible','on')
        else
            CLOSE_VALVES([VIDs.FEED,VIDs.BYPASS,VIDs.EXIT])
            CLOSE_VALVES([2:7,9:18])
            set(hObject, 'BackgroundColor',GuIformat.color.c)
            TSMessage(strcat({' Experiment Stopped'}),GuIformat.ScriptDir);
            set(hObject, 'String','Run')
            GuIformat.STOP = 1
        end
        
        function WashChamber(WashMatrix)
            
            if sum(sum(WashMatrix)) > 0
                CLOSE_VALVES([2:7,9:18])
                QDTime = str2num(get(GuIformat.EXPTqdEDT,'String'));
                QDstate = get(GuIformat.EXPTqdCB,'Value');
                
                BypassTime = str2num(get(GuIformat.EXPTbpEDT,'String'));
                BPstate = get(GuIformat.EXPTbpCB,'Value');
                
                ChamWashTime = str2num(get(GuIformat.EXPTChamEDT,'String'));
                
                
                MediaTypes = unique(WashMatrix(:,2))
                MediaTypes(MediaTypes == 0) = [];
                
                
                
                OPEN_VALVES(VIDs.Waste)
                set(GuIformat.WASTE, 'BackgroundColor',GuIformat.color.o)
                for i = [MediaTypes]'
                    LIGAND_Callback(i)

                    pause(.5)
                    %WASH QUICK DUMP
                    if GuIformat.STOP == 0 && QDstate == 1
                        OPEN_VALVES(VIDs.QuickDamp)
                        set(GuIformat.QuickDump, 'BackgroundColor',GuIformat.color.o)
                        count = 0
                        while count < QDTime && GuIformat.STOP == 0
                            pause(1)
                            count = count + 1
                        end
                        set(GuIformat.QuickDump, 'BackgroundColor',GuIformat.color.c)
                        CLOSE_VALVES(VIDs.QuickDamp)
                    end
                    
                    %WASH BYPASS
                    OPEN_VALVES(VIDs.BYPASS)
                    for j = [1:32]
                        if WashMatrix(j,2) == i
                            pause(.5)
                            if GuIformat.STOP == 0 && BPstate == 1
                                OPEN_VALVES([RowMult(j)])
                                set(GuIformat.ChamQD(j,2), 'BackgroundColor',GuIformat.color.o)
                                count = 0
                                while count < BypassTime && GuIformat.STOP == 0
                                    pause(1)
                                    count = count + 1
                                end
                                set(GuIformat.ChamQD(j,2), 'BackgroundColor',GuIformat.color.c)
                                CLOSE_VALVES([RowMult(j)])
                            end
                            pause(.5)
                        end
                    end
                    CLOSE_VALVES(VIDs.BYPASS)
                    OPEN_VALVES([VIDs.FEED,VIDs.EXIT])
                    %FEED CHAMBERS
                    for j = [1:32]
                        if WashMatrix(j,2) == i
                            if GuIformat.STOP == 0
                                TSMessage(strcat({' Started washing chamber '},num2str(j),{' with input '},get(GuIformat.LigCon(i,2),'String')),GuIformat.ScriptDir);
                                OPEN_VALVES([RowMult(j)])
                                set(GuIformat.ChamQD(j,1), 'BackgroundColor',GuIformat.color.o)
                                count = 0
                                while count < ChamWashTime && GuIformat.STOP == 0
                                    pause(1)
                                    count = count + 1
                                end
                                CLOSE_VALVES([RowMult(j)])
                                set(GuIformat.ChamQD(j,1), 'BackgroundColor',GuIformat.color.c)
                                
                                TSMessage(strcat({' Stopped washing chamber '},num2str(j),{' with input '},get(GuIformat.LigCon(i,2),'String')),GuIformat.ScriptDir);
                            end
                        end
                    end
                    pause(.5)
                    LIGAND_Callback(i)
                    pause(.5)
                    
                end
                OPEN_VALVES([VIDs.QuickDamp,VIDs.RowValvs(1:6)])
                pause(1)
                CLOSE_VALVES([VIDs.Waste,VIDs.QuickDamp,VIDs.RowValvs(1:6)])
                set(GuIformat.WASTE, 'BackgroundColor',GuIformat.color.c)
                OPEN_VALVES([2:7,9:18])
            end
        end
        
    end

GuIformat.PauseButton = uicontrol(Control,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Pause',...
    'Position',[.55 0 .15 1],...
    'HandleVisibility','off',...
    'BackgroundColor',GuIformat.color.c,...
    'Callback',@PauseExp);
    function PauseExp(hObject, callbackdata)
        
        if GuIformat.STOP == 0
            if get(GuIformat.WASTE,'BackgroundColor') == GuIformat.color.o
                CLOSE_VALVES(VIDs.Waste)
                set(GuIformat.WASTE, 'BackgroundColor',GuIformat.color.c)
                WasteState = 1
            end
            TSMessage(strcat({' User paused experiment.'}),GuIformat.ScriptDir);
            selection = questdlg('Resume Experiment?',...
                'Close Request Function',...
                'Yes','Yes');
            switch selection,
                case 'Yes',
                    TSMessage(strcat({' User resumed experiment.'}),GuIformat.ScriptDir);
            end
            if WasteState == 1
                OPEN_VALVES(VIDs.Waste)
                set(GuIformat.WASTE, 'BackgroundColor',GuIformat.color.o)
                WasteState = 0
            end
        end
        
    end

GuIformat.SaveButton = uicontrol(Control,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Save',...
    'Position',[.7 0 .15 1],...
    'HandleVisibility','off',...
    'BackgroundColor',GuIformat.color.c,...
    'Callback',@SaveExp);
    function SaveExp(hObject, callbackdata)
        TempExpData.Cond = zeros(32,6)
        for i = 32:-1:1
            TempExpData.Cond(i,1) = get(GuIformat.Cham(i,2),'Value') %Type
            TempExpData.Cond(i,2) = get(GuIformat.Cham(i,3),'Value') %Type
            TempExpData.Cond(i,3) = get(GuIformat.Cham(i,4),'Value'); %Input 1
            TempExpData.Cond(i,4) = get(GuIformat.Cham(i,5),'Value'); %Input 2
            TempExpData.Cond(i,5) = str2num(get(GuIformat.Cham(i,6),'String')); %Time 1
            TempExpData.Cond(i,6) = str2num(get(GuIformat.Cham(i,7),'String')) %Time 2
            
        end
        
        TempExpData.inputnames = cell(16,1)
        TempExpData.inputstates = zeros(16,1)
        for i = 16:-1:1
            TempExpData.inputnames{i} = get(GuIformat.LigCon(i,2),'String');
            TempExpData.inputstates(i) = get(GuIformat.LigCon(i,3),'Value');
        end
        
        TempExpData.SetupVars = zeros(4,3)
        TempExpData.SetupVars(1,1) = get(GuIformat.DebubbleChipCB,'Value')
        TempExpData.SetupVars(2,1) = get(GuIformat.CoatChipCB,'Value')
        TempExpData.SetupVars(2,2) = get(GuIformat.CoatChipPUM,'Value')
        TempExpData.SetupVars(2,3) = str2num(get(GuIformat.CoatChipEDT,'String'))
        TempExpData.SetupVars(3,1) = get(GuIformat.WashChipCB,'Value')
        TempExpData.SetupVars(3,2) = get(GuIformat.WashChipPUM,'Value')
        TempExpData.SetupVars(3,3) = str2num(get(GuIformat.WashChipEDT,'String'))
        TempExpData.SetupVars(4,1) = get(GuIformat.SeedChipCB,'Value')
        TempExpData.SetupVars(4,2) = get(GuIformat.SeedChipPUM,'Value')
        TempExpData.SetupVars(4,3) = str2num(get(GuIformat.SeedChipEDT,'String'))
        
        TempExpData.SetupChams = zeros(32,1)
        for i = 32:-1:1
            TempExpData.SetupChams(i) = get(GuIformat.SeedChamberCB(i),'Value')
        end
        
        TempExpData.ExpSettings = zeros(4,2)
        TempExpData.ExpSettings(1,1) = get(GuIformat.EXPTqdCB,'Value')
        TempExpData.ExpSettings(1,2) = str2num(get(GuIformat.EXPTqdEDT,'String'))
        TempExpData.ExpSettings(2,1) = get(GuIformat.EXPTbpCB,'Value')
        TempExpData.ExpSettings(2,2) = str2num(get(GuIformat.EXPTbpEDT,'String'))
        TempExpData.ExpSettings(3,2) = str2num(get(GuIformat.EXPTChamEDT,'String'))
        TempExpData.ExpSettings(4,2) = str2num(get(GuIformat.EXPTmaintenanceEDT,'String'))
        
        folder_name = uigetdir

        
        
        prompt = {'Enter experiment name:'};
        dlg_title = 'Save Experiment';
        num_lines = 1;
        defaultans = {datestr(now,'yymmdd')};
        x = inputdlg(prompt,dlg_title,num_lines,defaultans);
        ExpName = horzcat(char(x{1}),'.mat')
        target = fullfile(folder_name,ExpName)
        save(target,'TempExpData')
        
    end

GuIformat.LoadButton = uicontrol(Control,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Load',...
    'Position',[.85 0 .15 1],...
    'HandleVisibility','off',...
    'BackgroundColor',GuIformat.color.c,...
    'Callback',@LoadExp);
    function LoadExp(hObject, callbackdata)
        
        [filename, pathname] = uigetfile
        TempExpData.Cond = zeros(32,6)
        TempExpData.inputnames = cell(16,1)
        TempExpData.inputstates = zeros(16,1)
        TempExpData.SetupVars = zeros(4,3)
        TempExpData.SetupChams = zeros(32,1)
        TempExpData.ExpSettings = zeros(4,2)
        
        load(fullfile(pathname,filename))

        for i = 32:-1:1
            set(GuIformat.Cham(i,2),'Value',TempExpData.Cond(i,1)) %State
            set(GuIformat.Cham(i,3),'Value',TempExpData.Cond(i,2)) %Type
            set(GuIformat.Cham(i,4),'Value',TempExpData.Cond(i,3)); %Input 1
            set(GuIformat.Cham(i,5),'Value',TempExpData.Cond(i,4)); %Input 2
            set(GuIformat.Cham(i,6),'String',TempExpData.Cond(i,5)); %Time 1
            set(GuIformat.Cham(i,7),'String',TempExpData.Cond(i,6)); %Time 2
            
            if TempExpData.Cond(i,1)
                for j = 3:7
                    set(GuIformat.Cham(i,j),'Enable','On')
                end
            else
                for j = 3:7
                    set(GuIformat.Cham(i,j),'Enable','Off')
                end
            end
            if TempExpData.Cond(i,2) == 1
                set(GuIformat.Input1(i),'Visible','On')
                set(GuIformat.Input2(i),'Visible','On')
                set(GuIformat.Cham(i,4),'Visible','On')
                set(GuIformat.Cham(i,5),'Visible','On')
                set(GuIformat.Time1(i),'Visible','On')
                set(GuIformat.Time2(i),'Visible','Off')
                set(GuIformat.Cham(i,6),'Visible','On')
                set(GuIformat.Cham(i,7),'Visible','Off')
            elseif TempExpData.Cond(i,2) == 2
                set(GuIformat.Input1(i),'Visible','On')
                set(GuIformat.Input2(i),'Visible','Off')
                set(GuIformat.Cham(i,4),'Visible','On')
                set(GuIformat.Cham(i,5),'Visible','Off')
                set(GuIformat.Time1(i),'Visible','Off')
                set(GuIformat.Time2(i),'Visible','Off')
                set(GuIformat.Cham(i,6),'Visible','Off')
                set(GuIformat.Cham(i,7),'Visible','Off')
            elseif TempExpData.Cond(i,2) == 3
                set(GuIformat.Input1(i),'Visible','On')
                set(GuIformat.Input2(i),'Visible','On')
                set(GuIformat.Cham(i,4),'Visible','On')
                set(GuIformat.Cham(i,5),'Visible','On')
                set(GuIformat.Time1(i),'Visible','On')
                set(GuIformat.Time2(i),'Visible','On')
                set(GuIformat.Cham(i,6),'Visible','On')
                set(GuIformat.Cham(i,7),'Visible','On')
                
            end
        end

        for i = 16:-1:1
            set(GuIformat.LigCon(i,2),'String',TempExpData.inputnames{i});
            
            set(GuIformat.LigCon(i,3),'Value',TempExpData.inputstates(i));
        end
        for i = 1:32
            set(GuIformat.Cham(i,4),'String',TempExpData.inputnames);
            set(GuIformat.Cham(i,5),'String',TempExpData.inputnames);
        end
        set(GuIformat.SeedChipPUM,'String',TempExpData.inputnames);
        set(GuIformat.WashChipPUM,'String',TempExpData.inputnames);
        set(GuIformat.CoatChipPUM,'String',TempExpData.inputnames);
        
        set(GuIformat.DebubbleChipCB,'Value',TempExpData.SetupVars(1,1))
        set(GuIformat.CoatChipCB,'Value',TempExpData.SetupVars(2,1))
        set(GuIformat.CoatChipPUM,'Value',TempExpData.SetupVars(2,2))
        set(GuIformat.CoatChipEDT,'String',TempExpData.SetupVars(2,3))
        set(GuIformat.WashChipCB,'Value',TempExpData.SetupVars(3,1))
        set(GuIformat.WashChipPUM,'Value',TempExpData.SetupVars(3,2))
        set(GuIformat.WashChipEDT,'String',TempExpData.SetupVars(3,3))
        set(GuIformat.SeedChipCB,'Value',TempExpData.SetupVars(4,1))
        set(GuIformat.SeedChipPUM,'Value',TempExpData.SetupVars(4,2))
        set(GuIformat.SeedChipEDT,'String',TempExpData.SetupVars(4,3))

        for i = 32:-1:1
             set(GuIformat.SeedChamberCB(i),'Value',TempExpData.SetupChams(i))
        end
        
         set(GuIformat.EXPTqdCB,'Value',TempExpData.ExpSettings(1,1))
         set(GuIformat.EXPTqdEDT,'String',TempExpData.ExpSettings(1,2))
         set(GuIformat.EXPTbpCB,'Value',TempExpData.ExpSettings(2,1))
         set(GuIformat.EXPTbpEDT,'String',TempExpData.ExpSettings(2,2))
         set(GuIformat.EXPTChamEDT,'String',TempExpData.ExpSettings(3,2))
         set(GuIformat.EXPTmaintenanceEDT,'String',TempExpData.ExpSettings(4,2))
    end

end

function BoxControlPanel

global vc VIDs GuIformat;

Control = uipanel('Visible','on',...
    'Position',[0 0 .35 .05]);

%% Button Group
GuIformat.BoxControl(1) = uicontrol(Control,...
    'Units','normalized',...
    'Style','text',...
    'String','Serial Number 1:',...
    'Position',[0 .5 .2 .5],...
    'HandleVisibility','off');
GuIformat.BoxControl(2) = uicontrol(Control,...
    'Units','normalized',...
    'Style','text',...
    'String','Serial Number 2:',...
    'Position',[0 0 .2 .5],...
    'HandleVisibility','off');
GuIformat.BoxControl(3) = uicontrol(Control,...
    'Units','normalized',...
    'Style','edit',...
    'String','',...
    'Position',[.2 .5 .2 .5],...
    'HandleVisibility','off');
GuIformat.BoxControl(4) = uicontrol(Control,...
    'Units','normalized',...
    'Style','edit',...
    'String','',...
    'Position',[.2 0 .2 .5],...
    'HandleVisibility','off');

if exist(fullfile(cd,'VCBoxInfo.mat'))
    load(fullfile(cd,'VCBoxInfo.mat'))
    class(BoxSN)
    set(GuIformat.BoxControl(3),'String',BoxSN.BoxSN{1})
    set(GuIformat.BoxControl(4),'String',BoxSN.BoxSN{2})
end

GuIformat.BoxControl(6) = uicontrol(Control,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Disconnected',...
    'Position',[.6 0 .2 1],...
    'HandleVisibility','off',...
    'BackgroundColor',GuIformat.color.c,...
    'Callback',@CBConnect_PBCallback);
    function CBConnect_PBCallback(hObject,callbackdata)
        if GuIformat.BOXConnected == 0
            %Check for box connection
            %If not connected
            if GuIformat.DEBUGMODE == 0;
                %If debug mode off
                %% Parameters for connecting to two controller boxes
                % Number of boxes
                vc.num = 2;
                % Serial number of USB interface in box #1
                vc.info(1).sn = get(GuIformat.BoxControl(3),'String'); % My System - valves 0-23
                vc.info(1).handle = 0;
                vc.info(1).status = 0;
                vc.info(1).polarity = logical([zeros(1, 24)]);
                % Serial number of USB interface in box #2
                vc.info(2).sn = get(GuIformat.BoxControl(4),'String'); % My system first valves 24-47
                vc.info(2).handle = 0;
                vc.info(2).status = 0;
                vc.info(2).polarity = logical([zeros(1, 24)]);
                %% Open connection to controller boxes
                vc = vc_open_setup(vc);
                % Check status of both connections
                disp(['Status of box#1 = ' num2str(vc.info(1).status)]);
                disp(['Status of box#2 = ' num2str(vc.info(2).status)]);
                % Modify button & State
                GuIformat.BOXConnected = 1;
                set(GuIformat.BoxControl(6),'String','Connected');
                set(GuIformat.BoxControl(6),'BackgroundColor',GuIformat.color.o);
                
                BoxSN.BoxSN{1} = vc.info(1).sn
                BoxSN.BoxSN{2} = vc.info(2).sn;
                
                save(fullfile(cd,'VCBoxInfo.mat'),'BoxSN')
                OPEN_VALVES([0:47])
                CLOSE_VALVES(VIDs.ALLVALVES)
            else
                %If debug mode on
                h = warndlg('Debug mode must be turned off before a connection can be established.')
            end
        else
            if GuIformat.DEBUGMODE == 0;
                
                selection = questdlg('Leave valves closed?',...
                    'Close Request Function',...
                    'Yes','No','Yes');
                switch selection,
                    case 'Yes',

                            CLOSE_VALVES(VIDs.ALLVALVES)
                            vc = vc_close(vc, 1)

                            display('No VC connected.')

                    case 'No'
                        OPEN_VALVES([0:47])
                        vc = vc_close(vc, 1)
                end
            end
            %Modify button & State
            GuIformat.BOXConnected = 0;
            set(GuIformat.BoxControl(6),'String','Disconnected');
            set(GuIformat.BoxControl(6),'BackgroundColor',GuIformat.color.c);
        end
    end
GuIformat.BoxControl(7) = uicontrol(Control,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Debug Mode On',...
    'Position',[.8 0 .2 1],...
    'HandleVisibility','off',...
    'BackgroundColor',GuIformat.color.c,...
    'Callback',@DebugModeSwitch_PBCallback);
    function DebugModeSwitch_PBCallback(hObject,callbackdata)
        if GuIformat.DEBUGMODE == 1;
            GuIformat.DEBUGMODE = 0
            set(GuIformat.BoxControl(7),'String','Debug Mode Off');
            set(GuIformat.BoxControl(7),'BackgroundColor',GuIformat.color.o);
        else
            GuIformat.DEBUGMODE = 1
            set(GuIformat.BoxControl(7),'String','Debug Mode On');
            set(GuIformat.BoxControl(7),'BackgroundColor',GuIformat.color.c);
        end
    end
GuIformat.BoxControl(8) = uicontrol(Control,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Switch SNs',...
    'Position',[.4 0 .2 1],...
    'HandleVisibility','off',...
    'BackgroundColor',GuIformat.color.c,...
    'Callback',@SNsSwitch_PBCallback);
    function SNsSwitch_PBCallback(hObject,callbackdata)
        
        TOP = get(GuIformat.BoxControl(3),'String')
        BOTTOM = get(GuIformat.BoxControl(4),'String')
        set(GuIformat.BoxControl(3),'String',BOTTOM)
        set(GuIformat.BoxControl(4),'String',TOP)
        
    end
end

%% TOGGLE BUTTON FUNCTIONALITY

function CLOSE_VALVES(NUMBERS)% ***MANUALLY*** % ***MANUALLY*** % ***MANUALLY***
global vc VIDs GuIformat;
for i = NUMBERS
    set(GuIformat.DirCon(i+1), 'BackgroundColor',GuIformat.color.c);
end

if GuIformat.DEBUGMODE == 0
    values =  zeros(1,length(NUMBERS));
    b=size(NUMBERS,2);
    vc = vc_set_bits_ac(vc, NUMBERS, values);
    clear vc VIDs
end
end

function CLOSE_TIMED(NUMBERS,time)% ***MANUALLY*** % ***MANUALLY*** % ***MANUALLY***
global vc VIDs GuIformat;
for i = NUMBERS
    set(GuIformat.DirCon(i+1), 'BackgroundColor',GuIformat.color.c);
    if GuIformat.DEBUGMODE == 0
        values =  zeros(1,length(NUMBERS(i)));
        b=size(NUMBERS(i),2);
        vc = vc_set_bits_ac(vc, NUMBERS(i), values);
        clear vc VIDs
    end
    pause(time)
end
end

function OPEN_VALVES(NUMBERS)% ***MANUALLY*** % ***MANUALLY*** % ***MANUALLY***
global vc VIDs GuIformat;
values =  ones(1,length(NUMBERS));
for i = NUMBERS
    set(GuIformat.DirCon(i+1), 'BackgroundColor',GuIformat.color.o);
end

if GuIformat.DEBUGMODE == 0
    b=size(NUMBERS,2);
    vc = vc_set_bits_ac(vc, NUMBERS, values);
    clear vc VIDs
end
end

function OPEN_TIMED(NUMBERS,time)% ***MANUALLY*** % ***MANUALLY*** % ***MANUALLY***
global vc VIDs GuIformat;
values =  ones(1,length(NUMBERS));
for i = NUMBERS
    set(GuIformat.DirCon(i+1), 'BackgroundColor',GuIformat.color.o);
    if GuIformat.DEBUGMODE == 0
        b=size(NUMBERS(i),2);
        vc = vc_set_bits_ac(vc, NUMBERS(i), values(i));
        clear vc VIDs
    end
    pause(time)
end
end

function togglebutton_Callback(hObject,callbackdata)
global vc VIDs GuIformat;

button_state = get(hObject,'Value');
display(button_state)
NUMBERS = get(hObject,'UserData');
if button_state == get(hObject,'Max')
    set(hObject, 'BackgroundColor',GuIformat.color.o);
    for i = NUMBERS
        set(GuIformat.DirCon(i+1), 'BackgroundColor',GuIformat.color.o);
    end
    OPEN_VALVES(NUMBERS);
elseif button_state == get(hObject,'Min')
    set(hObject, 'BackgroundColor',GuIformat.color.c);
    for i = NUMBERS
        set(GuIformat.DirCon(i+1), 'BackgroundColor',GuIformat.color.c);
    end
    CLOSE_VALVES(NUMBERS);
end
end

%% LIGAND RECORDING FUNCTIONS

function LigandX_Callback(hObject,callbackdata)
global vc VIDs GuIformat
NUMBER = get(hObject,'UserData');

if VIDs.Ligands(NUMBER)== 0
    GuIformat.CurrentLigand = NUMBER;
    set(hObject, 'BackgroundColor',GuIformat.color.o);
    VIDs.Ligands(NUMBER) = 1;
    values =  VIDs.LigandValueMatrix(NUMBER,:);
    b=size(VIDs.LigandValves,2);
    if GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, VIDs.LigandValves, values);
    end
    for i = 1:8
        if values(i) == 0
            set(GuIformat.DirCon(i), 'BackgroundColor',GuIformat.color.c);
        else
            set(GuIformat.DirCon(i), 'BackgroundColor',GuIformat.color.o);
        end
    end
else
    GuIformat.CurrentLigand = 0;
    set(hObject, 'BackgroundColor',GuIformat.color.c);
    VIDs.Ligands(NUMBER) = 0;
    values= [0 0 0 0 0 0 0 0];
    b=size(VIDs.LigandValves,2);
    if GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, VIDs.LigandValves, values);
    end
    for i = 1:8
        if values(i) == 0
            set(GuIformat.DirCon(i), 'BackgroundColor',GuIformat.color.c);
        else
            set(GuIformat.DirCon(i), 'BackgroundColor',GuIformat.color.o);
        end
    end
end
end

function LIGAND_Callback(NUMBER)
global vc VIDs GuIformat

if VIDs.Ligands(NUMBER)== 0
    GuIformat.CurrentLigand = NUMBER;
    VIDs.Ligands(NUMBER) = 1;
    set(GuIformat.LigCon(NUMBER,1), 'BackgroundColor',GuIformat.color.o);
    values =  VIDs.LigandValueMatrix(NUMBER,:);
    b=size(VIDs.LigandValves,2);
    if GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, VIDs.LigandValves, values);
    end
else
    GuIformat.CurrentLigand = 0;
    VIDs.Ligands(NUMBER) = 0;
    set(GuIformat.LigCon(NUMBER,1), 'BackgroundColor',GuIformat.color.c);
    values= [0 0 0 0 0 0 0 0];
    b=size(VIDs.LigandValves,2);
    if GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, VIDs.LigandValves, values);
    end
end

for i = 1:8
    if values(i) == 0
        set(GuIformat.DirCon(i), 'BackgroundColor',GuIformat.color.c);
    else
        set(GuIformat.DirCon(i), 'BackgroundColor',GuIformat.color.o);
    end
end
end

%% CHAMBER MULTIPLEXING

function [valves] = RowMult(value)
global VIDs

            valves = VIDs.Row_Matrix(value,:);
            valves = VIDs.RowValvs .* valves;
            valves(valves == 0) = [];



end

%% SCRIPT INTERPRETER

function RUNTREATMENT(StepName,InputNumber,QuickDumpState,QuickDumpNum,QuickDumpTime,UpChannelFlush,DownChannelFlush,ChannelFlushTime,PumpState,PumpCycle,PumpInt,UpDown,ChCompConfig,Address,FeedTime,WasteState,WasteNum)
global GuIformat VIDs vc
%%%%%%%%%%%%%%%%% OPEN NEW PROGRESS WINDOW

TSMessage(strcat({'//Experiment//'},GuIformat.slctdScript,{'//Step//'},StepName,{'//Started//'}),cd);
crrntdots = '';
set(0,'units','pixels');
sspix = get(0,'screensize');
W = figure('Position',[sspix(3)*.05 sspix(4)*.05 (sspix(3)*.9) (sspix(4)*.4)]);
RunNoti = uicontrol(W,'Units','normalized',...
    'Position',[0 .5 1 .5],...
    'Style','text',...
    'FontSize',72,...
    'String','');
IncDots = uicontrol(W,'Units','normalized',...
    'Position',[0 0 1 .5],...
    'Style','text',...
    'FontSize',72,...
    'String',crrntdots);
rowlabs = 'ABCDEFGHIJKLMNOPQRSTUV';
temprows = any(Address,2);
tempchcomps = any(any(ChCompConfig,3),2)

ShiftValves = [VIDs.RowValvs,VIDs.RowTop,VIDs.RowBot,VIDs.ChannelOut,VIDs.Columns];
for q = 1:GuIformat.ChamberRows
    if temprows(q) == 1 && GuIformat.STOP == 0;
        set(GuIformat.TBC((GuIformat.ChamberRows+1)-q,2), 'BackgroundColor',GuIformat.color.i);
    end
end

for h = 1:3
    chcompvalves = [0 0 0];
    if tempchcomps(h) ~= 0
        for z = 1:2
            chcompvalves = [chcompvalves;transpose(VIDs.SOURCE(:,z)).*ChCompConfig(h,:,z)];
        end
    end
    chcompvalves(chcompvalves==0)=[];
end


if sum(temprows) > 0
    TSMessage(strcat({'//Experiment//'},GuIformat.slctdScript,{'//Step//'},StepName,'//Input//',num2str(get(GuIformat.LigCon(InputNumber,2),'String')),{'//Started//'}),cd)
    
    PAUSEchk
    
    if QuickDumpState == 1 && GuIformat.STOP == 0
        LIGAND_Callback(InputNumber);
        OPEN_VALVES(VIDs.QuickDamp(QuickDumpNum));
        set(GuIformat.QuickDump(QuickDumpNum), 'BackgroundColor',GuIformat.color.o);
        set(RunNoti,'String','QuickDump Flush')
        count = 0;
        while count < QuickDumpTime && GuIformat.STOP == 0
            PAUSEchk;
            pause(.5);
            count = count + .5
            if length(crrntdots) >= 4
                crrntdots = '';
            end
            crrntdots = strcat(crrntdots,'.');
            set(IncDots,'String',crrntdots)
        end
        CLOSE_VALVES(VIDs.QuickDamp(QuickDumpNum))
        set(GuIformat.QuickDump(QuickDumpNum), 'BackgroundColor',GuIformat.color.c);
        LIGAND_Callback(InputNumber);
    end
    
    %%%%%%%%%%%%%%%%%% OPEN WASTE
    
    if WasteState == 1 && GuIformat.STOP == 0
        OPEN_VALVES(VIDs.Waste(WasteNum));
        set(GuIformat.QWH(WasteNum), 'BackgroundColor',GuIformat.color.o);
    end
    
    %%%%%%%%%%%%%%%%% CHANNEL FLUSH STEP
    LIGAND_Callback(InputNumber);
    for q = 1:GuIformat.ChamberRows
        PAUSEchk
        if temprows(q) == 1 && GuIformat.STOP == 0;
            OPEN_VALVES(VIDs.Pump);
            set(GuIformat.Pump(1),'BackgroundColor',GuIformat.color.o)
            
            % Flush top channel
            if UpChannelFlush == 1 && GuIformat.STOP == 0
                OPEN_VALVES([VIDs.RowValvs((GuIformat.ChamberRows+1)-q),VIDs.RowTop,VIDs.ChannelOut(2)])
                set(GuIformat.TBC((GuIformat.ChamberRows+1)-q,2), 'BackgroundColor',GuIformat.color.o);
            end
            set(RunNoti,'String',strcat({'Row '},rowlabs(q),{' Top Flush'}))
            count = 0
            while UpChannelFlush == 1 && count < ChannelFlushTime && GuIformat.STOP == 0
                PAUSEchk;
                pause(.5);
                count = count + .5
                if length(crrntdots) >= 4
                    crrntdots = '';
                end
                crrntdots = strcat(crrntdots,'.');
                set(IncDots,'String',crrntdots)
            end
            if UpChannelFlush == 1
                CLOSE_VALVES([VIDs.RowValvs((GuIformat.ChamberRows+1)-q),VIDs.RowTop,VIDs.ChannelOut(2)])
                set(GuIformat.TBC((GuIformat.ChamberRows+1)-q,2), 'BackgroundColor',GuIformat.color.c);
            end
            
            % Flush down channel
            if DownChannelFlush == 1 && GuIformat.STOP == 0
                OPEN_VALVES([VIDs.RowValvs((GuIformat.ChamberRows+1)-q),VIDs.RowBot,VIDs.ChannelOut(1)])
                set(GuIformat.TBC((GuIformat.ChamberRows+1)-q,1), 'BackgroundColor',GuIformat.color.o);
            end
            set(RunNoti,'String',strcat({'Row '},rowlabs(q),{' Bottom Flush'}))
            count = 0
            while DownChannelFlush == 1 && count < ChannelFlushTime && GuIformat.STOP == 0
                PAUSEchk;
                pause(.5);
                count = count + .5
                if length(crrntdots) >= 4
                    crrntdots = '';
                end
                crrntdots = strcat(crrntdots,'.');
                set(IncDots,'String',crrntdots)
            end
            if DownChannelFlush == 1
                CLOSE_VALVES([VIDs.RowValvs((GuIformat.ChamberRows+1)-q),VIDs.RowBot,VIDs.ChannelOut(1)])
                set(GuIformat.TBC((GuIformat.ChamberRows+1)-q,1), 'BackgroundColor',GuIformat.color.c);
            end
            
            CLOSE_VALVES(VIDs.Pump)
            set(GuIformat.Pump(1),'BackgroundColor',GuIformat.color.c)
            PAUSEchk
        end
    end
    LIGAND_Callback(InputNumber);
    
    %%%%%%%%%%%%%% CHAMBER FLUSH
    if GuIformat.STOP == 0;
        PAUSEchk
        % Open path to chamber component valve
        set(RunNoti,'String','Changing Chamber Components');
        %LIGAND_Callback(InputNumber);
        pause(.5)
        OPEN_VALVES(VIDs.QuickDamp(QuickDumpNum));
        set(GuIformat.QuickDump(QuickDumpNum), 'BackgroundColor',GuIformat.color.o);
        pause(.5)
        for qq = length(VIDs.Pump):-1:1
            OPEN_VALVES(VIDs.Pump(qq))
            pause(.5)
        end
        set(GuIformat.Pump(1),'BackgroundColor',GuIformat.color.o)
        pause(.5)
        OPEN_TIMED(ShiftValves,.5)
    end
    
    for h = 1:3
        chcompvalves = [0 0 0];
        if tempchcomps(h) ~= 0 && GuIformat.STOP == 0;
            for z = 1:2
                chcompvalves = [chcompvalves;rot90(VIDs.SOURCE(:,z),3).*ChCompConfig(h,:,z)]
            end
            
            chcompvalves(chcompvalves==0)=[];
            for q = 1:GuIformat.ChamberRows
                if temprows(q) == 1
                    for k = 1:GuIformat.ChamberColumns
                        if Address(q,k) == 1
                            set(GuIformat.Cham(k,(GuIformat.ChamberRows+1)-q),'BackgroundColor',GuIformat.color.i)
                        end
                    end
                end
            end
            %Open chamber component
            for qq = 1:length(chcompvalves)
                OPEN_VALVES(chcompvalves(qq))
                % Find GUI component
                for z = 1:3
                    for v = 1:3
                        if ismember(get(GuIformat.ChComp(z,v),'Userdata'),chcompvalves(qq))
                            set(GuIformat.ChComp(z,v),'BackgroundColor',GuIformat.color.o)
                        end
                    end
                end
                pause(.5)
            end
            
            %Close path to chamber component
            CLOSE_TIMED(fliplr(ShiftValves),.5)
            
            CLOSE_TIMED(fliplr(VIDs.Pump),.5)
            
            set(GuIformat.Pump(1),'BackgroundColor',GuIformat.color.c)
            pause(.5)
            CLOSE_VALVES(VIDs.QuickDamp(QuickDumpNum));
            set(GuIformat.QuickDump(QuickDumpNum), 'BackgroundColor',GuIformat.color.c);
            pause(.5)
            
            %Open pump if necessary
            if PumpState == 0 && GuIformat.STOP == 0
                OPEN_TIMED(fliplr(VIDs.Pump),.5)
                set(GuIformat.Pump(1),'BackgroundColor',GuIformat.color.o)
                pause(.5)
            end
            
            %Flush Chambers

            OPEN_VALVES(VIDs.QuickDamp(QuickDumpNum))
            pause(.5)
            for q = 1:GuIformat.ChamberRows
                if temprows(q) == 1 && GuIformat.STOP == 0;
                    %Open row path
                    
                    if UpDown == 1
                        OPEN_TIMED([VIDs.RowValvs((GuIformat.ChamberRows+1)-q),VIDs.RowTop,VIDs.ChannelOut(1)],.5)
                        set(GuIformat.directionbttn,'Value',UpDown)
                    else
                        OPEN_TIMED([VIDs.RowValvs((GuIformat.ChamberRows+1)-q),VIDs.RowBot,VIDs.ChannelOut(2)],.5)
                        set(GuIformat.directionbttn,'Value',UpDown)
                    end
                    LIGAND_Callback(InputNumber);
                    CLOSE_VALVES(VIDs.QuickDamp(QuickDumpNum))
                    
                    
                    %Treat columns
                    for k = 1:GuIformat.ChamberColumns
                        if Address(q,k) == 1 && GuIformat.STOP == 0;
                            PAUSEchk
                            %Open column path
                            OPEN_VALVES(VIDs.Columns(k))
                            set(GuIformat.Cham(k,(GuIformat.ChamberRows+1)-q),'BackgroundColor',GuIformat.color.o)
                            set(RunNoti,'String',strcat({'Source: '},num2str(chcompvalves),{', Chamber: '},rowlabs(q),num2str(k),{', Flush: '},get(GuIformat.LigCon(InputNumber,2),'String')));
                            
                            %Pump or flow
                            if PumpState == 1 && GuIformat.STOP == 0
                                TSMessage(strcat({'//Experiment//'},GuIformat.slctdScript,{'//Step//'},StepName,{'//Side//'},num2str(chcompvalves),{'//Pump//'},num2str(GuIformat.Rows{q}),num2str(k),{'//Started//'}),cd)
                                set(GuIformat.Pump(2),'BackgroundColor',GuIformat.color.o)
                                set(GuIformat.Pump(2),'String','Running')
                                set(IncDots,'String','Pumping')
                                Pump(PumpCycle,PumpInt,VIDs.Pump)
                                set(GuIformat.Pump(2),'BackgroundColor',GuIformat.color.c)
                                set(GuIformat.Pump(2),'String','Run')
                                TSMessage(strcat({'//Experiment//'},GuIformat.slctdScript,{'//Step//'},StepName,{'//Side//'},num2str(chcompvalves),{'//Pump//'},num2str(GuIformat.Rows{q}),num2str(k),{'//Ended//'}),cd)
                            else
                                TSMessage(strcat({'//Experiment//'},GuIformat.slctdScript,{'//Step//'},StepName,{'//Side//'},num2str(chcompvalves),{'//Flow//'},num2str(GuIformat.Rows{q}),num2str(k),{'//Started//'}),cd)
                                count = 0
                                while count <= FeedTime && GuIformat.STOP == 0
                                    PAUSEchk;
                                    pause(.5);
                                    count = count + .5
                                    if length(crrntdots) >= 4
                                        crrntdots = '';
                                    end
                                    crrntdots = strcat(crrntdots,'.');
                                    set(IncDots,'String',crrntdots)
                                end
                                TSMessage(strcat({'//Experiment//'},GuIformat.slctdScript,{'//Step//'},StepName,{'//Source//'},num2str(chcompvalves),{'//Flow//'},num2str(GuIformat.Rows{q}),num2str(k),{'//Ended//'}),cd)
                                PAUSEchk
                            end
                            
                            %close column path
                            CLOSE_VALVES(VIDs.Columns(k))
                            set(GuIformat.Cham(k,(GuIformat.ChamberRows+1)-q),'BackgroundColor',GuIformat.color.c)
                            PAUSEchk
                        end
                    end
                    
                    
                    
                    %Close row path
                    LIGAND_Callback(InputNumber);
                    OPEN_VALVES(VIDs.QuickDamp(QuickDumpNum))
                    pause(.5)
                    if UpDown == 1
                        CLOSE_TIMED([VIDs.RowValvs((GuIformat.ChamberRows+1)-q),VIDs.RowTop,VIDs.ChannelOut(1)],.5)
                    else
                        CLOSE_TIMED([VIDs.RowValvs((GuIformat.ChamberRows+1)-q),VIDs.RowBot,VIDs.ChannelOut(2)],.5)
                    end
                    
                end
            end

            CLOSE_VALVES(VIDs.QuickDamp(QuickDumpNum))
            pause(.5)
            
            %Close pump if necessary
            if PumpState == 0
                for qq = length(VIDs.Pump):-1:1
                    CLOSE_VALVES(VIDs.Pump(qq))
                    pause(.5)
                end
                set(GuIformat.Pump(1),'BackgroundColor',GuIformat.color.c)
                pause(.5)
            end
            
            set(RunNoti,'String','Changing Chamber Components');
            % Open path to chamber component valve
            pause(.5)
            OPEN_VALVES(VIDs.QuickDamp(QuickDumpNum));
            set(GuIformat.QuickDump(QuickDumpNum), 'BackgroundColor',GuIformat.color.o);
            pause(.5)
            for qq = length(VIDs.Pump):-1:1
                OPEN_VALVES(VIDs.Pump(qq))
                pause(.5)
            end
            set(GuIformat.Pump(1),'BackgroundColor',GuIformat.color.o)
            pause(.5)
            OPEN_TIMED(ShiftValves,.5)
            
            %CLOSE chamber component
            for qq = 1:length(chcompvalves)
                CLOSE_VALVES(chcompvalves(qq))
                % Find GUI component
                for z = 1:3
                    for v = 1:3
                        if ismember(get(GuIformat.ChComp(z,v),'Userdata'),chcompvalves(qq))
                            set(GuIformat.ChComp(z,v),'BackgroundColor',GuIformat.color.c)
                        end
                    end
                end
                pause(.5)
            end
            

        end
    end
    
    %Close path to chamber component
    CLOSE_TIMED(fliplr(ShiftValves),.5)
    CLOSE_TIMED(fliplr(VIDs.Pump),.5)
    set(GuIformat.Pump(1),'BackgroundColor',GuIformat.color.c)
    pause(.5)
    CLOSE_VALVES(VIDs.QuickDamp(QuickDumpNum));
    set(GuIformat.QuickDump(QuickDumpNum), 'BackgroundColor',GuIformat.color.c);
    pause(.5)
    %LIGAND_Callback(InputNumber);
    pause(.5)
    
    if WasteState == 1
        CLOSE_VALVES(VIDs.Waste(WasteNum));
        set(GuIformat.QWH(WasteNum), 'BackgroundColor',GuIformat.color.c);
    end
    

    TSMessage(strcat({'//Experiment//'},GuIformat.slctdScript,{'//Step//'},StepName,'//Input//',num2str(get(GuIformat.LigCon(InputNumber,2),'String')),{'//Ended//'}),cd);
    PAUSEchk
end
for q = 1:GuIformat.ChamberRows
    if temprows(q) == 1
        set(GuIformat.TBC((GuIformat.ChamberRows+1)-q,2), 'BackgroundColor',GuIformat.color.c);
        for k = 1:GuIformat.ChamberColumns
            if Address(q,k) == 1
                set(GuIformat.Cham(k,(GuIformat.ChamberRows+1)-q),'BackgroundColor',GuIformat.color.c)
            end
        end
    end
end
close(W);
end

%% PUMP FUNCTION

function Pump(CYCLES,INTERVAL,VALVES)
% Left to Right 0100	0110	0010	0011	0001	1001
global vc VIDs GuIformat;
NUMVALVES = length(VALVES);
GuIformat.STOP = 0;
numbers = VALVES;
i=0;
while i < CYCLES && GuIformat.STOP == 0
    i=i+1;
    values =  [0, 1, 0, 0];
    if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, numbers, values);
    end
    pause(INTERVAL);
    pumpvis(numbers,values)
    % State 2
    values =  [0, 1, 1, 0];
    if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, numbers, values);
    end
    pause(INTERVAL);
    pumpvis(numbers,values)
    % State 3
    values =  [0, 0, 1, 0];
    if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, numbers, values);
    end
    pause(INTERVAL);
    pumpvis(numbers,values)
    % State 4
    values =  [0, 0, 1, 1];
    if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, numbers, values);
    end
    pause(INTERVAL);
    pumpvis(numbers,values)
    % State 5
    values =  [0, 0, 0, 1];
    if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, numbers, values);
        
        pause(INTERVAL);
    end
    pumpvis(numbers,values)
    % State 6
    values =  [1, 0, 0, 1];
    if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, numbers, values);
    end
    pause(INTERVAL);
    pumpvis(numbers,values)
    % State 7
    values =  [1, 0, 0, 0];
    if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, numbers, values);
    end
    pause(INTERVAL);
    pumpvis(numbers,values)
    % State 8
    values =  [1, 1, 0, 0];
    if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, numbers, values);
    end
    pause(INTERVAL);
    pumpvis(numbers,values)
    PAUSEchk
end
CLOSE_VALVES(numbers)

CLOSE_VALVES(numbers)

end

function pumpvis(numbers,values)
global GuIformat
count = length(numbers);
for q = 1:count
    if values(q) == 1
        set(GuIformat.DirCon(numbers(q)+1),'BackgroundColor',GuIformat.color.o)
    else
        set(GuIformat.DirCon(numbers(q)+1),'BackgroundColor',GuIformat.color.c)
    end
end
end

%% PAUSE FUNCTION

function PAUSEchk()

global vc VIDs GuIformat

while GuIformat.PAUSE == 1
    pause(.5);
end

end

%% LOGGING TOOL
function M = TSMessage(string,directory)
f = strcat(date,'.txt')
mkdir(directory,'logs')
message = strcat(datestr(now), string)
dlmwrite(fullfile(directory,'logs',f),message,'delimiter','','-append')
end